// ***************************************************************************
//  Libreria de scripts de Javascript
// Copyright 2003-2005 Jos Manuel Alonso. Todos los derechos reservados.
// Fichero: menucontextual.js.js
// Este fichero implementa las funciones javascript de la clase MenuContextual
// ***************************************************************************
var ctx_grissistema="#d4d0c8"
var ctx_azulmarino="#0a266a";
var ctx_blanco="#ffffff";
var ctx_negro="#000000";
var ctx_grissombra="#808080";

gmenuctx=new Array(); // Guarda el ltimo menu flotante
var idxmnu=0 // Indice de los menus flotantes
var currentItem=null;
var currentPadresubmenu;
var currentPadreY;

var botonraton=null;
//____________________________________________________________________________
//	
//	Esta funcin muestra un menu contextual 
// Parmetros:
//		- x: Coordenada x de referencia
//		- y: Coordenada y de referencia
//		- menuctx: Objeto DIV contenedor del menu contextual
//____________________________________________________________________________
function muestra_contextual(x,y,menuctx){
	var margen=0
	dpzx=16
	dpzy=16
	wtop=calculatop_ctx(y,dpzy,margen,menuctx) // Calcula posicin del menu contextual
	wleft=calculaleft_ctx(x,dpzx,margen,menuctx)
	ftop=wtop+parseInt(document.body.scrollTop) // Tiene en cuenta el scrolling
	fleft=wleft+parseInt(document.body.scrollLeft)
	menuctx.style.top=ftop
	menuctx.style.left=fleft
	menuctx.style.visibility="visible"
	menuctxSetSelectedIndex(menuctx,-1) // Coloca el nuevo indice
	gmenuctx[idxmnu++]=menuctx;
}
//____________________________________________________________________________
// Se ejecuta cuando se posiciona el cursor dentro de un item de algn men
// contextual.
// Parmetros:
//	- item: El item (objeto TR) donde se ha colocado el ratn 
//____________________________________________________________________________
function sobre_contextual(item){
	var menuctx=contextual(item) 
	var idx=menuctxSelectedIndex(menuctx) // Indice del Item seleccionado
	if (idx!=item.id){ // Si cambio de item
		desmarcar_item(menuctx) // Desmarca item anterior
		marcar_item(item); // Marca el actual item
		currentItem=item;
	}
}
//____________________________________________________________________________
// Se ejecuta cuando se posiciona el cursor fuera de un item de algn men contextual.
// Parmetros:
//	- item: El item (objeto TR) donde se ha descolocado el ratn 
//____________________________________________________________________________
function fuera_contextual(menuctx){
	return;
	// Hay que usar otra tencica para ocultar submenus cuando te sales del menu padre
	if(!EnContextual(event.clientX,event.clientY,menuctx)){// Comprueba que el cursor est  en el submenu contextual
		var idx=menuctxSelectedIndex(menuctx) // Indice del Item seleccionado
		if (idx!=-1){
			var item=menuctxItem(menuctx,idx) // toma el item Item 
			if(item!=null){
				if (item.name==""){
					desmarcar_item(menuctx); // Desmarca el item del anterior menu contextual
					menuctxSetSelectedIndex(menuctx,-1) // Coloca el nuevo indice
				}
			}
		}
	}
}
//____________________________________________________________________________
//
// Quita el resalte de un item y oculta los posibles submenus que tuviera 
// Parametros:
//	- menuctx: El objeto DIV al que pertenece el item (objeto TR)
//____________________________________________________________________________
function desmarcar_item(menuctx){
	var idx=menuctxSelectedIndex(menuctx) // Indice Item
	if (idx!=-1){
		var itant=menuctxItem(menuctx,idx) // Item
		marca_desmarca_contextual(itant,ctx_grissistema,ctx_negro,false)
		if (itant.name!=""){ // Tiene submenu
			var menuctx=document.getElementById(itant.name);
			desmarcar_item(menuctx)
			menuctx.style.visibility="hidden";
		}
	}
}
//____________________________________________________________________________
//
// Hace resaltar el item del menu contextual donde se coloca el cursor.
// Si este item tuviese un submenu contextual,ste tambin aparecera.
// Adems, actualiza el campo oculto de cada DIV donde se guarda el ndice
// del item selecionado.
//
// Parametros:
//	- item: El objeto <TR>
//____________________________________________________________________________
function marcar_item(item){
	marca_desmarca_contextual(item,ctx_azulmarino,ctx_blanco,true) // Marca el item
	if (item.name!=""){ // Existe submenu contextual
		currentPadresubmenu=item
		currentPadreY=event.clientY
		setTimeout ("muestra_submenu();", 550); 
	}
	menuctxSetSelectedIndex(contextual(item),item.id) // Coloca el nuevo indice
}
//____________________________________________________________________________
//
// Muestra un submenu
// Parametros:
//	- item: El objeto <TR> padre del submenu
//____________________________________________________________________________
function muestra_submenu(){
	if(currentPadresubmenu==currentItem){
		var objdiv=contextual(currentPadresubmenu) 
		var menuctx=document.getElementById(currentPadresubmenu.name); // Obtiene el submenu
		desmarcar_item(menuctx)  // Desmarca el   submenu por si  se ha usado anteriormente
		wleft=subcalculaleft_ctx(objdiv,menuctx) // La x en funcin del padre
		wtop=subcalculatop_ctx(currentPadreY,menuctx) // La y depende de la longitud del submenu
		menuctx.style.top=wtop
		menuctx.style.left=wleft
		menuctx.style.visibility="visible";
		menuctxSetSelectedIndex(menuctx,-1) // Coloca el nuevo indice
		gmenuctx[idxmnu++]=menuctx;
	}
}
//____________________________________________________________________________
//
// Calcula coordenada top para el menu contextual que se mostrar.
// Parametros:
//	- oriy : Coordenada Y del objeto que provoca el evento
//	- dpzy : Desplazamiento sobre el eje y
//	- margen : Margen para que el menu aparezca un poco separado del ese objeto
//	- menuctx: El menu (objeto DIV) que se mostrar
//____________________________________________________________________________
function calculatop_ctx(oriy,dpzy,margen,menuctx){ // Calcula Y del menu contextual
	largodiv=parseInt(menuctx.offsetHeight)
	var wtop=oriy+dpzy+margen
	if (wtop+largodiv>parseInt(document.body.clientHeight)){
		var nwtop=oriy-dpzy-margen-largodiv
		if (nwtop>0) wtop=nwtop
	}
	return(wtop)
}
//____________________________________________________________________________
//
// Calcula coordenada left para el menu contextual que se mostrar.
// Parametros:
//	- orix : Coordenada X del objeto que provoca el evento
//	- dpzx : Desplazamiento sobre el eje x
//	- margen : Margen para que el menu aparezca un poco separado del ese objeto
//	- menuctx: El menu (objeto DIV) que se mostrar
//____________________________________________________________________________
function calculaleft_ctx(orix,dpzx,margen,menuctx){ // Calcula Y del menu contextual
	anchodiv=parseInt(menuctx.offsetWidth)
	var wleft=orix+dpzx+margen
	var maximodpl=parseInt(document.body.clientWidth)
	if (wleft+anchodiv>maximodpl){ // Si no cabe a la derecha
		var nwleft=orix-dpzx-margen-anchodiv // lo intenta a la izda.
		if (nwleft>0) wleft=nwleft
		else{
			wleft=maximodpl-dpzx-margen-anchodiv;
			if(wleft<document.body.scrollLeft) wleft=document.body.scrollLeft+16
		}
	}
	
	return(wleft)
}
//____________________________________________________________________________
//
// Calcula coordenada top para el submenu contextual que se mostrar.
// Parametros:
//	- y : Coordenada Y de la pantalla donde se hizo click
//	- menuctx: El submenu (objeto DIV) que se mostrar
//____________________________________________________________________________
function subcalculatop_ctx(y,menuctx){ // Calcula el posicionamiento (y) del DIV ( SUBmenu contextual)
	var dpl=0
	largodiv=parseInt(menuctx.offsetHeight)
	var wtop=y+dpl+parseInt(document.body.scrollTop)
	if (parseInt(wtop+largodiv)>parseInt(document.body.clientHeight+parseInt(document.body.scrollTop))){
		var nwtop=y+parseInt(document.body.scrollTop)-16-largodiv
		if (nwtop>0) wtop=nwtop
	}
	return(wtop)
}
//____________________________________________________________________________
//
// Calcula coordenada left para el submenu contextual que se mostrar.
// Parametros:
//	- padrediv : Objeto DIV padre del submenu a mostrar
//	- menuctx: El submenu (objeto DIV) que se mostrar
//____________________________________________________________________________
function subcalculaleft_ctx(padrediv,menuctx){ // Calcula el posicionamiento (x) del DIV ( SUBmenu contextual)
	anchopadrediv=parseInt(padrediv.offsetWidth) // Ancho del div padre
	anchomenuctx=parseInt(menuctx.offsetWidth) // Ancho del div 
	leftpadrediv=padrediv.style.pixelLeft // Coordenada x del div padre
	desplazamiento=leftpadrediv+anchopadrediv-4 // Desplazamiento
	var wleft=parseInt(desplazamiento)
	var maximodpl=parseInt(document.body.clientWidth)+parseInt(document.body.scrollLeft)
	if (wleft+anchomenuctx>maximodpl){
		var nwleft=leftpadrediv-anchomenuctx
		if (nwleft>0) wleft=nwleft
		else{
			wleft=maximodpl-anchomenuctx;
			if(wleft<document.body.scrollLeft) wleft=document.body.scrollLeft+18
		}
	}
	return(wleft)
}
//____________________________________________________________________________
//
// Detecta si ha hecho fuera del menu contextual pasado como parametro
// Parametros:
//	- x : Coordenada X de la pantalla donde se hizo click
//	- y : Coordenada Y de la pantalla donde se hizo click
//	- menuctx: El submenu (objeto DIV)
//____________________________________________________________________________
function EnContextual(x,y,menuctx){
	origen_x=parseInt(menuctx.offsetLeft)-parseInt(document.body.scrollLeft)
	origen_y=parseInt(menuctx.offsetTop)-parseInt(document.body.scrollTop)
	anchodiv=parseInt(menuctx.offsetWidth)
	largodiv=parseInt(menuctx.offsetHeight)

	if ( x>=origen_x && x<=origen_x+anchodiv && y>=origen_y  && y<=origen_y+largodiv  ) return true
	return(false)
}
//____________________________________________________________________________
//
// Detecta si el menu contextual tiene items con imgenes asociadas
// Devuelve true en caso afirmativo y false en caso contrario.
//____________________________________________________________________________
function MenuconImagen(o){
	while(o.tagName!="INPUT"){
		o=document.all[o.sourceIndex+1]
		if (o.tagName=="IMG")
			if (o.name!="swsbfn")
				return(true)
	}
	return(false);
}
//____________________________________________________________________________
//
// Marca o desmarca items dependiendo del parametro sw.
// Si sw=true marca, si sw=false demarca
//____________________________________________________________________________
function marca_desmarca_contextual(o,fondo,color,sw){
	var opadre=o;
	if (MenuconImagen(opadre)) i0=2; else i0=1;
	nh=opadre.children.length;
	for (i=i0;i<nh-1;i++){
		o=opadre.children[i];
		if (o.children.length>0){
			h=o.children[0];
			if (h.name=="swsbfn"){ // imagen switch submenu
				o.style.backgroundColor=fondo
				o.style.color=color
				if (sw) 
					h.src="../images/flotantes/swsbfb.gif";
				else
					h.src="../images/flotantes/swsbfn.gif";
			}
			else{ // imagen del item
				if (sw){ // Marcar
					h.style.border=1
					h.style.borderStyle="solid"
					h.style.borderTopColor=ctx_blanco
					h.style.borderRightColor=ctx_grissombra
					h.style.borderBottomColor=ctx_grissombra
					h.style.borderLeftColor=ctx_blanco
				}
				else // Desmarcar
					h.style.border=0
			}
		}
		else{
			o.style.backgroundColor=fondo
			o.style.color=color
		}
	}
}
//____________________________________________________________________________
//
// Esta funcin devuelve el objeto DIV al que pertenece el item <TR>  
// Parametros:
//	- o: El objeto <TR>
//____________________________________________________________________________
function contextual(o){
	while(o.tagName!="DIV")
		o=document.all[o.sourceIndex-1]
	return(o)
}
//____________________________________________________________________________
//
// Esta funcin devuelve el objeto <tr> apuntado por el indice
// Parametros:
//	- o: El objeto <TBODY> que contiene los items (<TR>) o el DIV
//  - i: el indice del item
//____________________________________________________________________________
function menuctxItem(o,idx){
	if (o.tagName=="DIV"){
		while(o.tagName!="TBODY")
			o=document.all[o.sourceIndex+1]
	}
	var opadre=o;
	nh=opadre.children.length;
	for (i=0;i<nh;i++){
		o=opadre.children[i];
		if (parseInt(o.id)==idx) return(o)
	}
	return(null)
}
//____________________________________________________________________________
//
// Esta funcin actualiza el nuevo el indice del item seleccionado
// Parametros:
//	- o: El item (objeto <TR>) que se ha seleccionado 
//  - i: El valor del indice
//____________________________________________________________________________
function menuctxSetSelectedIndex(o,i){
	oinput=document.all[o.sourceIndex+1];
	while(oinput.tagName!="INPUT")
		oinput=document.all[oinput.sourceIndex+1]
	oinput.value=i;
}
//____________________________________________________________________________
//
// Esta funcin devuelve el indice del item seleccionado
// Parametros:
//	-o : El objeto DIV que contiene el menu contextual o un hijo de l 
//____________________________________________________________________________
function menuctxSelectedIndex(o){
	while(o.tagName!="INPUT")
		o=document.all[o.sourceIndex+1]
	return(o.value)
}
//____________________________________________________________________________
//
//	Se ejecuta cada vez que se mueve el puntero del ratn. Se usa para desmarca
//	cualquier item de menu contextual que estuviese activo
//____________________________________________________________________________
function click_de_raton(){
	botonraton=event.button
	if (gmenuctx.length>0)
		reset_contextual(event.clientX,event.clientY);
	event.returnValue=true;
}
//____________________________________________________________________________
function reset_contextual(x,y){
	var swm=false;
	for (var i=0;i<idxmnu;i++ ){
		if (gmenuctx[i].style.visibility=="visible")
			swm=swm || EnContextual(x,y,gmenuctx[i])
	}
	if (!swm){ // No se han hecho click en ningn menu contextual
		for (var i=0;i<idxmnu;i++ ){
			gmenuctx[i].style.visibility="hidden";
			desmarcar_item(gmenuctx[i]);
			gmenuctx[i]=null
		}
		idxmnu=0;
	}
}
//____________________________________________________________________________
//
//	Redirecciona el evento onmousedown a la funcin de usuario especificada. 
//____________________________________________________________________________
document.onmousedown = click_de_raton; // Redefine el evento onmousedown
